%define nfsv4	1
%define	name	nfs4-utils
%define	version	1.0.6
%define release	2mdk

Summary:	The utilities for Linux NFS server.
Name:		%{name}
Version:	%{version}
Release:	%{release}
URL:		ftp://ftp.kernel.org:/pub/linux/utils/nfs
License:	GPL
Group:		Networking/Other
Source0:	nfs-utils-%{version}.tar.bz2
Source1:	nfs.doc.tar.bz2
Source2:	nfs-utils-1.0.6-mandrake.tar.bz2

Patch0:		nfs-utils-0.2beta-nowrap.patch.bz2
Patch1:		install-prefix.patch.bz2
Patch2:		nfs-utils-1.0.5-statdpath.patch.bz2
Patch3:		nfs-utils-0.3.3.statd-manpage.patch.bz2
Patch4:		nfs-utils-1.0.3-aclexport.patch.bz2
Patch5:		nfs-utils-1.0.6-zerostats.patch.bz2
Patch6:		nfs-utils-1.0.6-mountd.patch.bz2
Patch7:		nfs-utils-1.0.6-expwarn.patch.bz2

%if %{nfsv4}
# (oe) these patches originates mostly from:
# http://www.citi.umich.edu/projects/nfsv4/linux/nfs-utils-patches/
Patch20:	nfs-utils-nfsv4-pseudoflavor-clients.patch.bz2
Patch21:	nfs-utils-nfsv4-mountd_flavors.patch.bz2
Patch22:	nfs-utils-nfsv4-upcall_export_check.patch.bz2
Patch25:	nfs-utils-nfsv4-add_idmapd.patch.bz2
Patch26:	nfs-utils-nfsv4-idmapd.patch.bz2
Patch30:	nfs-utils-1.0.6-nfsv4-add_gssd.diff.bz2
Patch31:	nfs-utils-nfsv4-gssd.patch.bz2
Patch35:	nfs-utils-nfsv4-redhat-only.patch.bz2
%endif
Patch100:	nfs-utils-1.0.6-pie.patch.bz2

Requires:	nfs4-utils-clients
Requires:	kernel >= 2.6.0
Requires:	portmap >= 4.0
%if %{nfsv4}
Requires:	modutils >= 2.4.26
BuildRequires:	krb5-devel >= 1.3
%endif
PreReq:		rpm-helper
Buildroot:	%{_tmppath}/%{name}-root

%description
The nfs-utils package provides a daemon for the kernel NFS server and
related tools, which provides a much higher level of performance than the
traditional Linux NFS server used by most users.

This package also contains the showmount program.  Showmount queries the
mount daemon on a remote host for information about the NFS (Network File
System) server on the remote host.  For example, showmount can display the
clients which are mounted on that host.

%package	clients
Summary:	The utilities for Linux NFS client.
Group:		Networking/Other
Requires:	kernel >= 2.6.0
Requires:	portmap >= 4.0
PreReq:		rpm-helper

%description	clients
The nfs-utils package provides a daemon for the kernel NFS server and
related tools, which provides a much higher level of performance than the
traditional Linux NFS server used by most users.

This package also contains the showmount program.  Showmount queries the
mount daemon on a remote host for information about the NFS (Network File
System) server on the remote host.  For example, showmount can display the
clients which are mounted on that host.

%prep

%setup -q -n nfs-utils-%{version} -a1 -a2

%if ! %{nfsv4}
%patch0 -p0
%endif

%patch1 -p1 -b .prefix
%patch2 -p1 -b .statdpath
%patch3 -p1 -b .statd-manpage
%patch4 -p1 -b .aclexp
%patch5 -p1 -b .zerostats
%patch6 -p1 -b .mountd
%patch7 -p1 -b .expwarn

%if %{nfsv4}
%patch20 -p1 -b .v4
%patch21 -p1 -b .v4mountd
%patch22 -p1 -b .v4upcall
%patch25 -p1 -b .add_idmapd
%patch26 -p1 -b .idmapd
%patch30 -p1 -b .add_gssd
%patch31 -p1 -b .gssd
%patch35 -p1 -b .rhonly
%endif

%patch100 -p1 -b .pie
%ifarch s390 s390x
perl -pi -e 's/-fpie/-fPIE/' */*/Makefile
%endif

%build

cat > config.cache << EOF
ac_cv_func_innetgr=yes
EOF

%configure \
    --cache-file=config.cache \
    --disable-rquotad

make all

%install
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

install -d %{buildroot}{/sbin,/usr/sbin}
install -d %{buildroot}%{_mandir}/{man5,man8}
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_localstatedir}/nfs/statd

make install_prefix=%{buildroot} \
    MANDIR=%{buildroot}%{_mandir} \
    SBINDIR=%{buildroot}%{_prefix}/sbin \
    install

install -m0755 tools/rpcdebug/rpcdebug %{buildroot}/sbin/
install -m0755 mandrake/nfs.init %{buildroot}%{_initrddir}/nfs
install -m0755 mandrake/nfslock.init %{buildroot}%{_initrddir}/nfslock
install -m0755 mandrake/nfs.sysconfig %{buildroot}/etc/sysconfig/nfs

%if %{nfsv4}
install -m0755 mandrake/rpcidmapd.init %{buildroot}%{_initrddir}/rpcidmapd
install -m0755 mandrake/rpcgssd.init %{buildroot}%{_initrddir}/rpcgssd
install -m0755 mandrake/rpcsvcgssd.init %{buildroot}%{_initrddir}/rpcsvcgssd
install -m0644 mandrake/idmapd.conf %{buildroot}%{_sysconfdir}/idmapd.conf
install -m0644 mandrake/gssapi_mech.conf %{buildroot}%{_sysconfdir}/gssapi_mech.conf
install -d %{buildroot}%{_localstatedir}/nfs/rpc_pipefs
%endif

touch %{buildroot}/var/lib/nfs/rmtab
mv %{buildroot}/usr/sbin/{rpc.lockd,rpc.statd} %{buildroot}/sbin/

cat > README.MDK << EOF
Q U I C K   S T A R T   G U I D E
---------------------------------

Add the following to the /etc/fstab file:

rpc_pipefs /var/lib/nfs/rpc_pipefs rpc_pipefs defaults 0 0
nfsd /proc/fs/nfsd nfsd defaults 0 0

Run "mount -a", and start the nfs server stuff

Regards // Oden Eriksson
EOF


%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

%post
%_post_service nfs

%if %{nfsv4}
%_post_service rpcidmapd
%_post_service rpcgssd
%_post_service rpcsvcgssd
%endif

%create_ghostfile %{_localstatedir}/nfs/xtab root root 644
%create_ghostfile %{_localstatedir}/nfs/etab root root 644
%create_ghostfile %{_localstatedir}/nfs/rmtab root root 644

%preun
%_preun_service nfs

%if %{nfsv4}
%_preun_service rpcidmapd
%_preun_service rpcgssd
%_preun_service rpcsvcgssd
%endif

%pre clients
%_pre_useradd rpcuser %{_localstatedir}/nfs /bin/false

%post clients
%_post_service nfslock 

%preun clients
%_preun_service nfslock

%postun clients
%_postun_userdel rpcuser

%files
%defattr(-,root,root)
%doc README ChangeLog COPYING README.MDK
%doc nfs/*.html nfs/*.ps linux-nfs/*
%attr(0755,root,root) %config(noreplace) %{_initrddir}/nfs
%config(noreplace) %{_sysconfdir}/sysconfig/nfs
%config(noreplace) %ghost %{_localstatedir}/nfs/xtab
%config(noreplace) %ghost %{_localstatedir}/nfs/etab
%config(noreplace) %ghost %{_localstatedir}/nfs/rmtab
/sbin/rpcdebug
%{_sbindir}/exportfs
%{_sbindir}/nfsstat
%{_sbindir}/nhfsgraph
%{_sbindir}/nhfsnums
%{_sbindir}/nhfsrun
%{_sbindir}/nhfsstone
%{_sbindir}/rpc.mountd
%{_sbindir}/rpc.nfsd
%if %{nfsv4}
%attr(0755,root,root) %config(noreplace) %{_initrddir}/rpcidmapd
%attr(0755,root,root) %config(noreplace) %{_initrddir}/rpcgssd
%attr(0755,root,root) %config(noreplace) %{_initrddir}/rpcsvcgssd
/usr/sbin/rpc.idmapd
/usr/sbin/rpc.gssd
/usr/sbin/rpc.svcgssd
%config(noreplace) %{_sysconfdir}/idmapd.conf
%config(noreplace) %{_sysconfdir}/gssapi_mech.conf
%dir %{_localstatedir}/nfs/rpc_pipefs
%endif
%{_mandir}/man5/exports.5*
%{_mandir}/man7/nfsd.7*
%{_mandir}/man8/exportfs.8*
%{_mandir}/man8/mountd.8*
%{_mandir}/man8/nfsd.8*
%{_mandir}/man8/nfsstat.8*
%{_mandir}/man8/nhfsgraph.8*
%{_mandir}/man8/nhfsnums.8*
%{_mandir}/man8/nhfsrun.8*
%{_mandir}/man8/nhfsstone.8*
%{_mandir}/man8/rpc.mountd.8*
%{_mandir}/man8/rpc.nfsd.8*
%if %{nfsv4}
%{_mandir}/man5/idmapd.conf.5*
%{_mandir}/man5/rpc.idmapd.conf.5*
%{_mandir}/man8/gssd.8*
%{_mandir}/man8/idmapd.8*
%{_mandir}/man8/rpc.gssd.8*
%{_mandir}/man8/rpc.idmapd.8*
%{_mandir}/man8/rpc.svcgssd.8*
%{_mandir}/man8/svcgssd.8*
%endif

%files clients
%defattr(-,root,root)
%doc README
%attr(0755,root,root) %config(noreplace) %{_initrddir}/nfslock
/sbin/rpc.lockd
/sbin/rpc.statd
%{_sbindir}/showmount
%{_mandir}/man8/lockd.8*
%{_mandir}/man8/rpc.lockd.8*
%{_mandir}/man8/rpc.statd.8*
%{_mandir}/man8/statd.8*
%{_mandir}/man8/showmount.8*
%dir %{_localstatedir}/nfs
%dir %{_localstatedir}/nfs/state
%dir %attr(0700,rpcuser,rpcuser) /var/lib/nfs/statd

%changelog
* Sat Aug 07 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.6-2mdk
- fix invalid build host

* Sat Aug 07 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.6-1mdk
- initial mandrake package, based on nfs-utils with fedora patches
  but with a twist
- made a tarball (S2) for the mandrake initscripts and config 
  (easier to maintain)

* Sun Dec 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.6-1mdk
- 1.0.6
- partly synced S10 & S11 with fedora and updated S12
- misc spec file fixes

* Tue Jul 22 2003 Juan Quintela <quintela@mandrakesoft.com> 1.0.5-1mdk
- included the rest of created programs & manpages.
  Inquiring minds need nhfsgraph, nfgsnums and nhfsrun.
- brown paper bug upstream, I tested it and it worked, problem is that
  it just worked once :(.
- 1.0.5.

* Wed Jul 16 2003 Juan Quintela <quintela@mandrakesoft.com> 1.0.4-1mdk
- remove patch5 (time.h) already included upstream.
- remove patch2 no-chroot (not needed after removing patch0).
- remove patch0 (drop privs) included better patch upstream.
- 1.0.4.

* Tue Jul 01 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.3-1mdk
- new release (kernel-2.5.x support)
- rediff patch 0

* Wed Jun 04 2003 Per yvind Karlsen <peroyvind@sintrax.net> 1.0.1-2mdk
- remove unpackaged files
- fix E: nfs-utils-clients no-prereq-on rpm-helper
- drop obsolete Prefix tag

* Tue Jul 23 2002 Juan Quintela <quintela@mandrakesoft.com> 1.0.1-1mdk
- then merge them with nfs-1.0.1 ones.
- merged nfs.init & nfslock.init with rh ones.
- merge with rh 1.0.1.pre7-1.
- use %configure.
- 1.0.1.

* Thu Jul 11 2002 Frederic Lepied <flepied@mandrakesoft.com> 0.3.3-4mdk
- add rpcuser

* Tue Jan 15 2002 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.3.3-3mdk
- Make some files as %ghost.

* Fri Dec  7 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.3.3-2mdk
- Fix some rpmlints.

* Fri Sep 28 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.3.3-1mdk
- 0.3.3.

* Sat Sep  1 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.3.1-7mdk
- Merge rh scripts.
- Remove quota from here it's provided by quota.

* Sun Apr  1 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.3.1-6mdk
- Move dir /var/lib/nfs/statd to clients packge or rpc.statd wouldn't
  work.

* Thu Mar 28 2001 Florin Grad <florin@mandrakesoft.com> 0.3.1-5mdk
- -fno-omit-frame-pointer

* Sun Mar 18 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.3.1-4mdk
- Requires last setup package for rpcuser.
- Make /var/lib/nfs/statd as rpcuser,rpcuser.

* Thu Mar 15 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.3.1-3mdk
- Fix incorrect file specifications in statd manpage. (rh).
- disable tcp_wrapper support (rh).
- Don't do a chroot(2) after dropping privs, in statd (rh).
- #include <time.h> patch.

* Fri Mar 02 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.3.1-2mdk
- Fix chkconfig entry in initscripts.

* Mon Feb 19 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.3.1-1mdk
- Move rpc.lockd and rpc.statd to /sbin
- Merge with rh changes.
- 0.3.1.

* Thu Dec  7 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.2.1-3mdk
- Nfslock only when we have a lockd into the kernel.

* Mon Oct 09 2000 Florin Grad <florin@mandrakesoft.com> 0.2.1-2mdk
- chkconfig is now 345 ... instead of - 60 ...

* Fri Sep 29 2000 Frederic Lepied <flepied@mandrakesoft.com> 0.2.1-1mdk
- 0.2.1 bug fix release.

* Thu Sep 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.2-5mdk
- Florin or chmou sucks, pidofproc come from the
  /etc/init.d/functions.

* Wed Sep 27 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.2-4mdk
- nfslock: where pidofproc come from ? use pidof instead (florin).

* Thu Sep 21 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.2-3mdk
- nfslock: don't kill lockd processes that do not have an executable
  (i.e. kernel threads).

* Thu Sep 07 2000 Florin Grad <florin@mandrakesoft.com> 0.2-2mdk
- added noreplace for %{_inirddir}/(nfs|nfslock)

* Thu Sep 07 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 0.2-1mdk
- s/0.1.9.1/0.2/;

* Wed Aug 30 2000 Florin Grad <florin@mandrakesoft.com> 0.1.9.1-4mdk
- changing some macros

* Wed Jul 26 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.1.9.1-3mdk
- BM
- more macros

* Mon Jul 10 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.1.9.1-2mdk
- fix build with latest rpm macros

* Wed Jul 05 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.1.9.1-1mdk
- new release (mainly turning gcc warnings off)
- fix build as non root with tmpdir

* Mon Jul  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.1.9-1mdk
- 0.1.9.

* Tue Jun 27 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.1.8-1mdk
- 0.1.8.
- Macrozifications.

* Sun May 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.1.7-3mdk
- Fix path call (/usr/sbin !> /sbin/).
- Launch always rpc.statd.

* Wed Apr 06 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 0.1.7-2mdk
- Renamed linusinit patch to mdkinit.
- Do not grep for linus in /proc/version, but for mdk 
  (Thanks to Jrgen Zimmermann)

* Wed Mar 22 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 0.1.7-1mdk
- Update to 0.1.7.
- Fix group.

* Tue Jan 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.1.6-1mdk
- 0.1.6.

* Tue Dec 21 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 0.1.5.
- Fix init script with kernel-linus.

* Mon Dec 06 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 0.1.4.

* Tue Nov 30 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 0.1.3.

* Thu Nov 25 1999 Pixel <pixel@linux-mandrake.com>
- fixed %defattr
- split in 2 packages: nfs-utils-clients & nfs-utils (for server)

* Fri Nov 19 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Last cvs version.

* Wed Oct 27 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- 0.1.2

* Tue Oct 26 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 0.1.1.

* Tue Oct 19 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- First Spec files based on original version of H.J Lu.
